Index: trunk/source/geometry/solids/CSG/src/G4Sphere.cc
===================================================================
--- trunk/source/geometry/solids/CSG/src/G4Sphere.cc	(revision 1227)
+++ trunk/source/geometry/solids/CSG/src/G4Sphere.cc	(revision 1228)
@@ -1469,9 +1345,59 @@
       // Second >= 0 root should be considered
         
-      if ( fSTheta + fDTheta < pi )
+      if ( eTheta < pi )
       {
         t1 = 1 - v.z()*v.z()*(1 + tanETheta2) ;
         t2 = pDotV2d - p.z()*v.z()*tanETheta2 ;
-        
+        if (t1)
+        { 
+          b  = t2/t1 ;
+          c  = dist2ETheta/t1 ;
+          d2 = b*b - c ;
+
+          if (d2 >= 0)
+          {
+            d = std::sqrt(d2) ;
+            s = -b + d ;    // Second root
+
+            if ( (s >= 0) && (s < snxt) )
+            {
+              xi    = p.x() + s*v.x() ;
+              yi    = p.y() + s*v.y() ;
+              zi    = p.z() + s*v.z() ;
+              rhoi2 = xi*xi + yi*yi   ;
+              radi2 = rhoi2 + zi*zi   ;
+
+              if ( (radi2 <= tolORMax2)
+                && (radi2 >= tolORMin2)
+                && (zi*(eTheta - halfpi) <= 0) )
+              {
+                if (!fFullPhiSphere && rhoi2)   // Check phi intersection
+                {
+                  cosPsi = (xi*cosCPhi + yi*sinCPhi)/std::sqrt(rhoi2) ;
+                  if (cosPsi >= cosHDPhiOT)
+                  {
+                    snxt = s ;
+                  }
+                }
+                else
+                {
+                  snxt = s ;
+                }
+              }
+            }
+          }
+        }
+      }
+    }  
+    else if ( pTheta > tolETheta ) 
+    { 
+      // dist2ETheta<-kRadTolerance*0.5 && dist2STheta>0)
+      // Inside (theta > etheta+tol) e-theta cone
+      // First root of etheta cone, second if first root 'imaginary'
+
+      t1 = 1 - v.z()*v.z()*(1 + tanETheta2) ;
+      t2 = pDotV2d - p.z()*v.z()*tanETheta2 ;
+      if (t1)
+      {  
         b  = t2/t1 ;
         c  = dist2ETheta/t1 ;
@@ -1481,7 +1407,12 @@
         {
           d = std::sqrt(d2) ;
-          s = -b + d ;    // Second root
-
-          if (s >= 0 && s < snxt)
+          s = -b - d ;    // First root
+          zi    = p.z() + s*v.z();
+
+          if ( (s < 0) || (zi*(eTheta - halfpi) > 0) )
+          {
+            s = -b + d ;           // second root
+          }
+          if ( (s >= 0) && (s < snxt) )
           {
             xi    = p.x() + s*v.x() ;
@@ -1492,8 +1423,8 @@
 
             if ( (radi2 <= tolORMax2)
-              && (radi2 >= tolORMin2)
-              && (zi*(fSTheta + fDTheta - halfpi) <= 0) )
-            {
-              if (segPhi && rhoi2)   // Check phi intersection
+              && (radi2 >= tolORMin2) 
+              && (zi*(eTheta - halfpi) <= 0) )
+            {
+              if (!fFullPhiSphere && rhoi2)  // Check phi intersection
               {
                 cosPsi = (xi*cosCPhi + yi*sinCPhi)/std::sqrt(rhoi2) ;
@@ -1511,55 +1442,4 @@
         }
       }
-    }  
-    else if ( pTheta > tolETheta ) 
-    { 
-      // dist2ETheta<-kRadTolerance*0.5 && dist2STheta>0)
-      // Inside (theta > etheta+tol) e-theta cone
-      // First root of etheta cone, second if first root `imaginary'
-
-      t1 = 1 - v.z()*v.z()*(1 + tanETheta2) ;
-      t2 = pDotV2d - p.z()*v.z()*tanETheta2 ;
-        
-      b  = t2/t1 ;
-      c  = dist2ETheta/t1 ;
-      d2 = b*b - c ;
-
-      if (d2 >= 0)
-      {
-        d = std::sqrt(d2) ;
-        s = -b - d ;    // First root
-        zi    = p.z() + s*v.z();
-
-        if (s < 0 || zi*(fSTheta + fDTheta - halfpi) > 0)
-        {
-          s = -b + d ;           // second root
-        }
-        if (s >= 0 && s < snxt)
-        {
-          xi    = p.x() + s*v.x() ;
-          yi    = p.y() + s*v.y() ;
-          zi    = p.z() + s*v.z() ;
-          rhoi2 = xi*xi + yi*yi   ;
-          radi2 = rhoi2 + zi*zi   ;
-
-          if ( (radi2 <= tolORMax2)
-            && (radi2 >= tolORMin2) 
-            && (zi*(fSTheta + fDTheta - halfpi) <= 0) )
-          {
-            if (segPhi && rhoi2)  // Check phi intersection
-            {
-              cosPsi = (xi*cosCPhi + yi*sinCPhi)/std::sqrt(rhoi2) ;
-              if (cosPsi >= cosHDPhiOT)
-              {
-                snxt = s ;
-              }
-            }
-            else
-            {
-              snxt = s ;
-            }
-          }
-        }
-      }
 
       // Possible intersection with STheta cone. 
@@ -1570,5 +1450,76 @@
         t1 = 1 - v.z()*v.z()*(1 + tanSTheta2) ;
         t2 = pDotV2d - p.z()*v.z()*tanSTheta2 ;
-
+        if (t1)
+        { 
+          b  = t2/t1 ;
+          c  = dist2STheta/t1 ;
+          d2 = b*b - c ;
+
+          if (d2 >= 0)
+          {
+            d = std::sqrt(d2) ;
+            s = -b + d ;    // Second root
+
+            if ( (s >= 0) && (s < snxt) )
+            {
+              xi    = p.x() + s*v.x() ;
+              yi    = p.y() + s*v.y() ;
+              zi    = p.z() + s*v.z() ;
+              rhoi2 = xi*xi + yi*yi   ;
+              radi2 = rhoi2 + zi*zi   ;
+
+              if ( (radi2 <= tolORMax2)
+                && (radi2 >= tolORMin2)
+                && (zi*(fSTheta - halfpi) <= 0) )
+              {
+                if (!fFullPhiSphere && rhoi2)   // Check phi intersection
+                {
+                  cosPsi = (xi*cosCPhi + yi*sinCPhi)/std::sqrt(rhoi2) ;
+                  if (cosPsi >= cosHDPhiOT)
+                  {
+                    snxt = s ;
+                  }
+                }
+                else
+                {
+                  snxt = s ;
+                }
+              }
+            }
+          }
+        }
+      }  
+    }     
+    else if ( (pTheta < tolSTheta + kAngTolerance)
+           && (fSTheta > halfAngTolerance) )
+    {
+      // In tolerance of stheta
+      // If entering through solid [r,phi] => 0 to in
+      // else try 2nd root
+
+      t2 = pDotV2d - p.z()*v.z()*tanSTheta2 ;
+      if ( (t2>=0 && tolIRMin2<rad2 && rad2<tolIRMax2 && fSTheta<halfpi)
+        || (t2<0  && tolIRMin2<rad2 && rad2<tolIRMax2 && fSTheta>halfpi)
+        || (v.z()<0 && tolIRMin2<rad2 && rad2<tolIRMax2 && fSTheta==halfpi) )
+      {
+        if (!fFullPhiSphere && rho2)  // Check phi intersection
+        {
+          cosPsi = (p.x()*cosCPhi + p.y()*sinCPhi)/std::sqrt(rho2) ;
+          if (cosPsi >= cosHDPhiIT)
+          {
+            return 0 ;
+          }
+        }
+        else
+        {
+          return 0 ;
+        }
+      }
+
+      // Not entering immediately/travelling through
+
+      t1 = 1 - v.z()*v.z()*(1 + tanSTheta2) ;
+      if (t1)
+      { 
         b  = t2/t1 ;
         c  = dist2STheta/t1 ;
@@ -1578,8 +1529,7 @@
         {
           d = std::sqrt(d2) ;
-          s = -b + d ;    // Second root
-
-          if ( (s >= 0) && (s < snxt) )
-          {
+          s = -b + d ;
+          if ( (s >= halfCarTolerance) && (s < snxt) && (fSTheta < halfpi) )
+          {  // ^^^^^^^^^^^^^^^^^^^^^  shouldn't it be >=0 instead ?
             xi    = p.x() + s*v.x() ;
             yi    = p.y() + s*v.y() ;
@@ -1592,5 +1542,79 @@
               && (zi*(fSTheta - halfpi) <= 0) )
             {
-              if (segPhi && rhoi2)   // Check phi intersection
+              if ( !fFullPhiSphere && rhoi2 )    // Check phi intersection
+              {
+                cosPsi = (xi*cosCPhi + yi*sinCPhi)/std::sqrt(rhoi2) ;
+                if ( cosPsi >= cosHDPhiOT )
+                {
+                  snxt = s ;
+                }
+              }
+              else
+              {
+                snxt = s ;
+              }
+            }
+          }
+        }
+      }
+    }   
+    else if ((pTheta > tolETheta-kAngTolerance) && (eTheta < pi-kAngTolerance))
+    {
+
+      // In tolerance of etheta
+      // If entering through solid [r,phi] => 0 to in
+      // else try 2nd root
+
+      t2 = pDotV2d - p.z()*v.z()*tanETheta2 ;
+
+      if (   ((t2<0) && (eTheta < halfpi)
+          && (tolIRMin2 < rad2) && (rad2 < tolIRMax2))
+        ||   ((t2>=0) && (eTheta > halfpi)
+          && (tolIRMin2 < rad2) && (rad2 < tolIRMax2))
+        ||   ((v.z()>0) && (eTheta == halfpi)
+          && (tolIRMin2 < rad2) && (rad2 < tolIRMax2))  )
+      {
+        if (!fFullPhiSphere && rho2)   // Check phi intersection
+        {
+          cosPsi = (p.x()*cosCPhi + p.y()*sinCPhi)/std::sqrt(rho2) ;
+          if (cosPsi >= cosHDPhiIT)
+          {
+            return 0 ;
+          }
+        }
+        else
+        {
+          return 0 ;
+        }
+      }
+
+      // Not entering immediately/travelling through
+
+      t1 = 1 - v.z()*v.z()*(1 + tanETheta2) ;
+      if (t1)
+      { 
+        b  = t2/t1 ;
+        c  = dist2ETheta/t1 ;
+        d2 = b*b - c ;
+
+        if (d2 >= 0)
+        {
+          d = std::sqrt(d2) ;
+          s = -b + d ;
+        
+          if ( (s >= halfCarTolerance)
+            && (s < snxt) && (eTheta > halfpi) )
+          {
+            xi    = p.x() + s*v.x() ;
+            yi    = p.y() + s*v.y() ;
+            zi    = p.z() + s*v.z() ;
+            rhoi2 = xi*xi + yi*yi   ;
+            radi2 = rhoi2 + zi*zi   ;
+
+            if ( (radi2 <= tolORMax2)
+              && (radi2 >= tolORMin2)
+              && (zi*(eTheta - halfpi) <= 0) )
+            {
+              if (!fFullPhiSphere && rhoi2)   // Check phi intersection
               {
                 cosPsi = (xi*cosCPhi + yi*sinCPhi)/std::sqrt(rhoi2) ;
@@ -1606,142 +1630,6 @@
             }
           }
-        }
-      }  
-    }     
-    else if ( (pTheta <tolSTheta + kAngTolerance)
-           && (fSTheta > kAngTolerance) )
-    {
-      // In tolerance of stheta
-      // If entering through solid [r,phi] => 0 to in
-      // else try 2nd root
-
-      t2 = pDotV2d - p.z()*v.z()*tanSTheta2 ;
-      if ( (t2>=0 && tolIRMin2<rad2 && rad2<tolIRMax2 && fSTheta<pi*.5)
-        || (t2<0  && tolIRMin2<rad2 && rad2<tolIRMax2 && fSTheta>pi*.5)
-        || (v.z()<0 && tolIRMin2<rad2 && rad2<tolIRMax2 && fSTheta==pi*.5) )
-      {
-        if (segPhi && rho2)  // Check phi intersection
-        {
-          cosPsi = (p.x()*cosCPhi + p.y()*sinCPhi)/std::sqrt(rho2) ;
-          if (cosPsi >= cosHDPhiIT)
-          {
-            return 0 ;
-          }
-        }
-        else
-        {
-          return 0 ;
-        }
-      }
-
-      // Not entering immediately/travelling through
-
-      t1 = 1 - v.z()*v.z()*(1 + tanSTheta2) ;
-      b  = t2/t1 ;
-      c  = dist2STheta/t1 ;
-      d2 = b*b - c ;
-
-      if (d2 >= 0)
-      {
-        d = std::sqrt(d2) ;
-        s = -b + d ;
-        if ( (s >= kCarTolerance*0.5) && (s < snxt) && (fSTheta < pi*0.5) )
-        {
-          xi    = p.x() + s*v.x() ;
-          yi    = p.y() + s*v.y() ;
-          zi    = p.z() + s*v.z() ;
-          rhoi2 = xi*xi + yi*yi   ;
-          radi2 = rhoi2 + zi*zi   ;
-
-          if ( (radi2 <= tolORMax2)
-            && (radi2 >= tolORMin2)
-            && (zi*(fSTheta - halfpi) <= 0) )
-          {
-            if ( segPhi && rhoi2 )    // Check phi intersection
-            {
-              cosPsi = (xi*cosCPhi + yi*sinCPhi)/std::sqrt(rhoi2) ;
-              if ( cosPsi >= cosHDPhiOT )
-              {
-                snxt = s ;
-              }
-            }
-            else
-            {
-              snxt = s ;
-            }
-          }
-        }
-      }
-    }   
-    else if ( (pTheta > tolETheta - kAngTolerance)
-           && ((fSTheta + fDTheta) < pi-kAngTolerance) )   
-    {
-
-      // In tolerance of etheta
-      // If entering through solid [r,phi] => 0 to in
-      // else try 2nd root
-
-      t2 = pDotV2d - p.z()*v.z()*tanETheta2 ;
-
-      if (
-    (t2<0    && (fSTheta+fDTheta) <pi*0.5 && tolIRMin2<rad2 && rad2<tolIRMax2)
- || (t2>=0   && (fSTheta+fDTheta) >pi*0.5 && tolIRMin2<rad2 && rad2<tolIRMax2)
- || (v.z()>0 && (fSTheta+fDTheta)==pi*0.5 && tolIRMin2<rad2 && rad2<tolIRMax2)
-         )
-      {
-        if (segPhi && rho2)   // Check phi intersection
-        {
-          cosPsi = (p.x()*cosCPhi + p.y()*sinCPhi)/std::sqrt(rho2) ;
-          if (cosPsi >= cosHDPhiIT)
-          {
-            return 0 ;
-          }
-        }
-        else
-        {
-          return 0 ;
-        }
-      }
-
-      // Not entering immediately/travelling through
-
-      t1 = 1 - v.z()*v.z()*(1 + tanETheta2) ;
-      b  = t2/t1 ;
-      c  = dist2ETheta/t1 ;
-      d2 = b*b - c ;
-
-      if (d2 >= 0)
-      {
-        d = std::sqrt(d2) ;
-        s = -b + d ;
-        
-        if ( (s >= kCarTolerance*0.5)
-          && (s < snxt) && ((fSTheta + fDTheta) > pi*0.5) )
-        {
-          xi    = p.x() + s*v.x() ;
-          yi    = p.y() + s*v.y() ;
-          zi    = p.z() + s*v.z() ;
-          rhoi2 = xi*xi + yi*yi   ;
-          radi2 = rhoi2 + zi*zi   ;
-
-          if ( (radi2 <= tolORMax2)
-            && (radi2 >= tolORMin2)
-            && (zi*(fSTheta + fDTheta - halfpi) <= 0) )
-          {
-            if (segPhi && rhoi2)   // Check phi intersection
-            {
-              cosPsi = (xi*cosCPhi + yi*sinCPhi)/std::sqrt(rhoi2) ;
-              if (cosPsi>=cosHDPhiOT)
-              {
-                snxt = s ;
-              }
-            }
-            else
-            {
-              snxt = s ;
-            }
-          }
-        }
-      }    
+        } 
+      }   
     }  
     else
@@ -1752,37 +1640,39 @@
       t1 = 1 - v.z()*v.z()*(1 + tanSTheta2) ;
       t2 = pDotV2d - p.z()*v.z()*tanSTheta2 ;
-
-      b  = t2/t1;
-      c  = dist2STheta/t1 ;
-      d2 = b*b - c ;
-
-      if (d2 >= 0)
-      {
-        d = std::sqrt(d2) ;
-        s = -b + d ;    // second root
-
-        if (s >= 0 && s < snxt)
-        {
-          xi    = p.x() + s*v.x() ;
-          yi    = p.y() + s*v.y() ;
-          zi    = p.z() + s*v.z() ;
-          rhoi2 = xi*xi + yi*yi   ;
-          radi2 = rhoi2 + zi*zi   ;
-
-          if ( (radi2 <= tolORMax2)
-            && (radi2 >= tolORMin2)
-            && (zi*(fSTheta - halfpi) <= 0) )
-          {
-            if (segPhi && rhoi2)   // Check phi intersection
-            {
-              cosPsi = (xi*cosCPhi + yi*sinCPhi)/std::sqrt(rhoi2) ;
-              if (cosPsi >= cosHDPhiOT)
+      if (t1)
+      { 
+        b  = t2/t1;
+        c  = dist2STheta/t1 ;
+        d2 = b*b - c ;
+
+        if (d2 >= 0)
+        {
+          d = std::sqrt(d2) ;
+          s = -b + d ;    // second root
+
+          if ((s >= 0) && (s < snxt))
+          {
+            xi    = p.x() + s*v.x() ;
+            yi    = p.y() + s*v.y() ;
+            zi    = p.z() + s*v.z() ;
+            rhoi2 = xi*xi + yi*yi   ;
+            radi2 = rhoi2 + zi*zi   ;
+
+            if ( (radi2 <= tolORMax2)
+              && (radi2 >= tolORMin2)
+              && (zi*(fSTheta - halfpi) <= 0) )
+            {
+              if (!fFullPhiSphere && rhoi2)   // Check phi intersection
+              {
+                cosPsi = (xi*cosCPhi + yi*sinCPhi)/std::sqrt(rhoi2) ;
+                if (cosPsi >= cosHDPhiOT)
+                {
+                  snxt = s ;
+                }
+              }
+              else
               {
                 snxt = s ;
               }
-            }
-            else
-            {
-              snxt = s ;
             }
           }
@@ -1791,37 +1681,39 @@
       t1 = 1 - v.z()*v.z()*(1 + tanETheta2) ;
       t2 = pDotV2d - p.z()*v.z()*tanETheta2 ;
-        
-      b  = t2/t1 ;
-      c  = dist2ETheta/t1 ;
-      d2 = b*b - c ;
-
-      if (d2 >= 0)
-      {
-        d = std::sqrt(d2) ;
-        s = -b + d;    // second root
-
-        if (s >= 0 && s < snxt)
-        {
-          xi    = p.x() + s*v.x() ;
-          yi    = p.y() + s*v.y() ;
-          zi    = p.z() + s*v.z() ;
-          rhoi2 = xi*xi + yi*yi   ;
-          radi2 = rhoi2 + zi*zi   ;
-
-          if ( (radi2 <= tolORMax2)
-            && (radi2 >= tolORMin2)
-            && (zi*(fSTheta + fDTheta - halfpi) <= 0) )
-          {
-            if (segPhi && rhoi2)   // Check phi intersection
-            {
-              cosPsi = (xi*cosCPhi + yi*sinCPhi)/std::sqrt(rhoi2) ;
-              if ( cosPsi >= cosHDPhiOT )
-              {
-                snxt=s;
-              }
-            }
-            else
-            {
-              snxt = s ;
+      if (t1)
+      {   
+        b  = t2/t1 ;
+        c  = dist2ETheta/t1 ;
+        d2 = b*b - c ;
+
+        if (d2 >= 0)
+        {
+          d = std::sqrt(d2) ;
+          s = -b + d;    // second root
+
+          if ((s >= 0) && (s < snxt))
+          {
+            xi    = p.x() + s*v.x() ;
+            yi    = p.y() + s*v.y() ;
+            zi    = p.z() + s*v.z() ;
+            rhoi2 = xi*xi + yi*yi   ;
+            radi2 = rhoi2 + zi*zi   ;
+
+            if ( (radi2 <= tolORMax2)
+              && (radi2 >= tolORMin2)
+              && (zi*(eTheta - halfpi) <= 0) )
+            {
+              if (!fFullPhiSphere && rhoi2)   // Check phi intersection
+              {
+                cosPsi = (xi*cosCPhi + yi*sinCPhi)/std::sqrt(rhoi2) ;
+                if ( cosPsi >= cosHDPhiOT )
+                {
+                  snxt=s;
+                }
+              }
+              else
+              {
+                snxt = s ;
+              }
             }
           }
@@ -1844,9 +1736,9 @@
 {
   G4double safe=0.0,safeRMin,safeRMax,safePhi,safeTheta;
-  G4double rho2,rad,rho;
-  G4double phiC,cosPhiC,sinPhiC,cosPsi,ePhi;
+  G4double rho2,rds,rho;
+  G4double cosPsi;
   G4double pTheta,dTheta1,dTheta2;
   rho2=p.x()*p.x()+p.y()*p.y();
-  rad=std::sqrt(rho2+p.z()*p.z());
+  rds=std::sqrt(rho2+p.z()*p.z());
   rho=std::sqrt(rho2);
 
@@ -1856,6 +1748,6 @@
   if (fRmin)
   {
-    safeRMin=fRmin-rad;
-    safeRMax=rad-fRmax;
+    safeRMin=fRmin-rds;
+    safeRMax=rds-fRmax;
     if (safeRMin>safeRMax)
     {
@@ -1869,5 +1761,5 @@
   else
   {
-    safe=rad-fRmax;
+    safe=rds-fRmax;
   }
 
@@ -1875,27 +1767,22 @@
   // Distance to phi extent
   //
-  if (fDPhi<twopi&&rho)
-  {
-    phiC=fSPhi+fDPhi*0.5;
-    cosPhiC=std::cos(phiC);
-    sinPhiC=std::sin(phiC);
-
+  if (!fFullPhiSphere && rho)
+  {
     // Psi=angle from central phi to point
     //
-    cosPsi=(p.x()*cosPhiC+p.y()*sinPhiC)/rho;
-    if (cosPsi<std::cos(fDPhi*0.5))
+    cosPsi=(p.x()*cosCPhi+p.y()*sinCPhi)/rho;
+    if (cosPsi<std::cos(hDPhi))
     {
       // Point lies outside phi range
       //
-      if ((p.y()*cosPhiC-p.x()*sinPhiC)<=0)
-      {
-        safePhi=std::fabs(p.x()*std::sin(fSPhi)-p.y()*std::cos(fSPhi));
+      if ((p.y()*cosCPhi-p.x()*sinCPhi)<=0)
+      {
+        safePhi=std::fabs(p.x()*sinSPhi-p.y()*cosSPhi);
       }
       else
       {
-        ePhi=fSPhi+fDPhi;
-        safePhi=std::fabs(p.x()*std::sin(ePhi)-p.y()*std::cos(ePhi));
-      }
-      if (safePhi>safe) safe=safePhi;
+        safePhi=std::fabs(p.x()*sinEPhi-p.y()*cosEPhi);
+      }
+      if (safePhi>safe)  { safe=safePhi; }
     }
   }
@@ -1903,15 +1790,15 @@
   // Distance to Theta extent
   //    
-  if ((rad!=0.0) && (fDTheta<pi))
-  {
-    pTheta=std::acos(p.z()/rad);
-    if (pTheta<0) pTheta+=pi;
+  if ((rds!=0.0) && (!fFullThetaSphere))
+  {
+    pTheta=std::acos(p.z()/rds);
+    if (pTheta<0)  { pTheta+=pi; }
     dTheta1=fSTheta-pTheta;
-    dTheta2=pTheta-(fSTheta+fDTheta);
+    dTheta2=pTheta-eTheta;
     if (dTheta1>dTheta2)
     {
       if (dTheta1>=0)             // WHY ???????????
       {
-        safeTheta=rad*std::sin(dTheta1);
+        safeTheta=rds*std::sin(dTheta1);
         if (safe<=safeTheta)
         {
@@ -1924,5 +1811,5 @@
       if (dTheta2>=0)
       {
-        safeTheta=rad*std::sin(dTheta2);
+        safeTheta=rds*std::sin(dTheta2);
         if (safe<=safeTheta)
         {
@@ -1933,5 +1820,5 @@
   }
 
-  if (safe<0) safe=0;
+  if (safe<0)  { safe=0; }
   return safe;
 }
@@ -1939,5 +1826,5 @@
 /////////////////////////////////////////////////////////////////////
 //
-// Calculate distance to surface of shape from `inside', allowing for tolerance
+// Calculate distance to surface of shape from 'inside', allowing for tolerance
 // - Only Calc rmax intersection if no valid rmin intersection
 
@@ -1952,4 +1839,10 @@
   ESide side=kNull,sidephi=kNull,sidetheta=kNull;  
 
+  static const G4double halfCarTolerance = kCarTolerance*0.5;
+  static const G4double halfAngTolerance = kAngTolerance*0.5;
+  const G4double halfRmaxTolerance = fRmaxTolerance*0.5;
+  const G4double halfRminTolerance = fRminTolerance*0.5;
+  const G4double Rmax_plus  = fRmax + halfRmaxTolerance;
+  const G4double Rmin_minus = (fRmin) ? fRmin-halfRminTolerance : 0;
   G4double t1,t2;
   G4double b,c,d;
@@ -1957,6 +1850,4 @@
   // Variables for phi intersection:
 
-  G4double sinSPhi,cosSPhi,ePhi,sinEPhi,cosEPhi;
-  G4double cPhi,sinCPhi,cosCPhi;
   G4double pDistS,compS,pDistE,compE,sphi2,vphi;
     
@@ -1966,21 +1857,14 @@
   G4double xi,yi,zi;      // Intersection point
 
-  // G4double Comp; // Phi intersection
-
-  G4bool segPhi;        // Phi flag and precalcs
-  G4double hDPhi,hDPhiOT,hDPhiIT; 
-  G4double cosHDPhiOT,cosHDPhiIT;
-
-  G4bool segTheta;                             // Theta flag and precals
-  G4double tanSTheta=0.,tanETheta=0., rhoSecTheta;
-  G4double tanSTheta2=0.,tanETheta2=0.;
+  // Theta precals
+  //
+  G4double rhoSecTheta;
   G4double dist2STheta, dist2ETheta, distTheta;
   G4double d2,s;
 
   // General Precalcs
-
+  //
   rho2 = p.x()*p.x()+p.y()*p.y();
   rad2 = rho2+p.z()*p.z();
-  //  G4double rad=std::sqrt(rad2);
 
   pTheta = std::atan2(std::sqrt(rho2),p.z());
@@ -1989,33 +1873,11 @@
   pDotV3d = pDotV2d+p.z()*v.z();
 
-  // Set phi divided flag and precalcs
-
-  if( fDPhi < twopi )
-  {
-    segPhi=true;
-    hDPhi=0.5*fDPhi;    // half delta phi
-    cPhi=fSPhi+hDPhi;;
-    hDPhiOT=hDPhi+0.5*kAngTolerance; // Outer Tolerant half delta phi 
-    hDPhiIT=hDPhi-0.5*kAngTolerance;
-    sinCPhi=std::sin(cPhi);
-    cosCPhi=std::cos(cPhi);
-    cosHDPhiOT=std::cos(hDPhiOT);
-    cosHDPhiIT=std::cos(hDPhiIT);
-  }
-  else
-  {
-    segPhi=false;
-  }
-
   // Theta precalcs
     
-  if ( fDTheta < pi )
-  {
-    segTheta  = true;
-    tolSTheta = fSTheta - kAngTolerance*0.5;
-    tolETheta = fSTheta + fDTheta + kAngTolerance*0.5;
-  }
-  else segTheta = false;
-
+  if ( !fFullThetaSphere )
+  {
+    tolSTheta = fSTheta - halfAngTolerance;
+    tolETheta = eTheta + halfAngTolerance;
+  }
     
   // Radial Intersections from G4Sphere::DistanceToIn
@@ -2034,23 +1896,10 @@
   //
   // => s=-pDotV3d+-std::sqrt(pDotV3d^2-(rad2-R^2))
-  //
-  // const G4double  fractionTolerance = 1.0e-12;
-
-  const G4double  flexRadMaxTolerance =            // kRadTolerance;
-    std::max(kRadTolerance, fEpsilon * fRmax);
-
-  const G4double  Rmax_plus = fRmax + flexRadMaxTolerance*0.5;
-
-  const G4double  flexRadMinTolerance = std::max(kRadTolerance, 
-                     fEpsilon * fRmin);
-
-  const G4double  Rmin_minus= (fRmin > 0) ? fRmin-flexRadMinTolerance*0.5 : 0 ;
-
-  if(rad2 <= Rmax_plus*Rmax_plus && rad2 >= Rmin_minus*Rmin_minus)
-    //  if(rad <= Rmax_plus && rad >= Rmin_minus)
+
+  if( (rad2 <= Rmax_plus*Rmax_plus) && (rad2 >= Rmin_minus*Rmin_minus) )
   {
     c = rad2 - fRmax*fRmax;
 
-    if (c < flexRadMaxTolerance*fRmax) 
+    if (c < fRmaxTolerance*fRmax) 
     {
       // Within tolerant Outer radius 
@@ -2065,7 +1914,7 @@
       d2 = pDotV3d*pDotV3d - c;
 
-      if( (c >- flexRadMaxTolerance*fRmax)       // on tolerant surface
-       && ((pDotV3d >=0) || (d2 < 0)) )          // leaving outside from Rmax 
-                                                 // not re-entering
+      if( (c >- fRmaxTolerance*fRmax)       // on tolerant surface
+       && ((pDotV3d >=0) || (d2 < 0)) )     // leaving outside from Rmax 
+                                            // not re-entering
       {
         if(calcNorm)
@@ -2092,11 +1941,11 @@
       d2 = pDotV3d*pDotV3d - c;
 
-      if ( c >- flexRadMinTolerance*fRmin ) // 2.0 * (0.5*kRadTolerance) * fRmin
-      {
-        if( c < flexRadMinTolerance*fRmin && 
-            d2 >= flexRadMinTolerance*fRmin && pDotV3d < 0 ) // leaving from Rmin
-        {
-          if(calcNorm)  *validNorm = false ;   // Rmin surface is concave         
-                       return snxt = 0 ;
+      if (c >- fRminTolerance*fRmin) // 2.0 * (0.5*kRadTolerance) * fRmin
+      {
+        if ( (c < fRminTolerance*fRmin)              // leaving from Rmin
+          && (d2 >= fRminTolerance*fRmin) && (pDotV3d < 0) )
+        {
+          if(calcNorm)  { *validNorm = false; }  // Rmin surface is concave         
+          return snxt = 0 ;
         }
         else
@@ -2119,5 +1968,5 @@
   // Theta segment intersection
 
-  if (segTheta)
+  if ( !fFullThetaSphere )
   {
     // Intersection with theta surfaces
@@ -2143,186 +1992,11 @@
     //
   
-    /* ////////////////////////////////////////////////////////
-
-    tanSTheta=std::tan(fSTheta);
-    tanSTheta2=tanSTheta*tanSTheta;
-    tanETheta=std::tan(fSTheta+fDTheta);
-    tanETheta2=tanETheta*tanETheta;
-      
-    if (fSTheta)
-    {
-      dist2STheta=rho2-p.z()*p.z()*tanSTheta2;
-    }
-    else
-    {
-      dist2STheta = kInfinity;
-    }
-    if (fSTheta + fDTheta < pi)
-    {
-      dist2ETheta = rho2-p.z()*p.z()*tanETheta2;
-    }
-    else
-    {
-      dist2ETheta = kInfinity ;
-    }
-    if (pTheta > tolSTheta && pTheta < tolETheta)   // Inside theta  
-    {
-      // In tolerance of STheta and possible leaving out to small thetas N-
-
-      if(pTheta < tolSTheta + kAngTolerance  && fSTheta > kAngTolerance)  
-      {
-        t2=pDotV2d-p.z()*v.z()*tanSTheta2 ; // =(VdotN+)*rhoSecSTheta
-
-        if( fSTheta < pi*0.5 && t2 < 0)
-        {
-          if(calcNorm) *validNorm = false ;
-          return snxt = 0 ;
-        }
-        else if(fSTheta > pi*0.5 && t2 >= 0)
-        {
-          if(calcNorm)
-          {
-            rhoSecTheta = std::sqrt(rho2*(1+tanSTheta2)) ;
-            *validNorm = true ;
-            *n = G4ThreeVector(-p.x()/rhoSecTheta,   // N-
-                               -p.y()/rhoSecTheta,
-                               tanSTheta/std::sqrt(1+tanSTheta2) ) ;
-          }
-          return snxt = 0 ;
-        }
-        else if( fSTheta == pi*0.5 && v.z() > 0)
-        {
-          if(calcNorm)
-          {
-            *validNorm = true ;
-            *n = G4ThreeVector(0,0,1) ;
-          }
-          return snxt = 0 ;
-        }
-      }
-
-      // In tolerance of ETheta and possible leaving out to larger thetas N+
-
-      if ( (pTheta  > tolETheta - kAngTolerance)
-        && (( fSTheta + fDTheta) < pi - kAngTolerance) )  
-      {
-        t2=pDotV2d-p.z()*v.z()*tanETheta2 ;
-        if((fSTheta+fDTheta)>pi*0.5 && t2<0)
-        {
-          if(calcNorm) *validNorm = false ;
-          return snxt = 0 ;
-        }
-        else if( (fSTheta+fDTheta) < pi*0.5 && t2 >= 0 )
-        {
-          if(calcNorm)
-          {
-            rhoSecTheta = std::sqrt(rho2*(1+tanETheta2)) ;
-            *validNorm = true ;
-            *n = G4ThreeVector( p.x()/rhoSecTheta,  // N+
-                                p.y()/rhoSecTheta,
-                                -tanETheta/std::sqrt(1+tanETheta2)  ) ; 
-          }
-          return snxt = 0 ;
-        }
-        else if( ( fSTheta+fDTheta) == pi*0.5 && v.z() < 0 )
-        {
-          if(calcNorm)
-          {
-            *validNorm = true ;
-            *n = G4ThreeVector(0,0,-1) ;
-          }
-          return snxt = 0 ;
-        }
-      }
-      if( fSTheta > 0 )
-      {       
-        // First root of fSTheta cone, second if first root -ve
-
-        t1 = 1-v.z()*v.z()*(1+tanSTheta2);
-        t2 = pDotV2d-p.z()*v.z()*tanSTheta2;
-        
-        b  = t2/t1;
-        c  = dist2STheta/t1;
-        d2 = b*b - c ;
-
-        if ( d2 >= 0 )
-        {
-          d = std::sqrt(d2) ;
-          s = -b - d ;    // First root
-
-          if ( s < 0 )
-          {
-            s = -b + d ;    // Second root
-          }
-          if (s > flexRadMaxTolerance*0.5 )   // && s<sr)
-          {
-            // check against double cone solution
-            zi=p.z()+s*v.z();
-            if (fSTheta<pi*0.5 && zi<0)
-            {
-              s = kInfinity ;  // wrong cone
-            }
-            if (fSTheta>pi*0.5 && zi>0)
-            {
-              s = kInfinity ;  // wrong cone
-            }
-            stheta = s ;
-            sidetheta = kSTheta ;
-          }
-        }
-      }
-
-      // Possible intersection with ETheta cone  
-      
-      if (fSTheta + fDTheta < pi)
-      {
-        t1 = 1-v.z()*v.z()*(1+tanETheta2);
-        t2 = pDotV2d-p.z()*v.z()*tanETheta2;        
-        b  = t2/t1;
-        c  = dist2ETheta/t1;
-        d2 = b*b-c ;
-
-        if ( d2 >= 0 )
-        {
-          d = std::sqrt(d2);
-          s = -b - d ;          // First root
-
-          if ( s < 0 )
-          {
-            s=-b+d;    // Second root
-          }
-          if (s > flexRadMaxTolerance*0.5 && s < stheta )
-          {
-            // check against double cone solution
-            zi=p.z()+s*v.z();
-            if (fSTheta+fDTheta<pi*0.5 && zi<0)
-            {
-              s = kInfinity ;  // wrong cone
-            }
-            if (fSTheta+fDTheta>pi*0.5 && zi>0)
-            {
-              s = kInfinity ;  // wrong cone
-            }
-          }
-          if (s < stheta)
-          {
-            stheta = s ;
-            sidetheta = kETheta ;
-          }
-        }
-      }
-    }  
-    */  ////////////////////////////////////////////////////////////
-
     if(fSTheta) // intersection with first cons
     {
-
-      tanSTheta = std::tan(fSTheta);
-
       if( std::fabs(tanSTheta) > 5./kAngTolerance ) // kons is plane z=0
       {
         if( v.z() > 0. ) 
         {
-          if ( std::fabs( p.z() ) <= flexRadMaxTolerance*0.5 )
+          if ( std::fabs( p.z() ) <= halfRmaxTolerance )
           {
             if(calcNorm)
@@ -2333,5 +2007,4 @@
             return snxt = 0 ;
           }  
-          // s = -p.z()/v.z();
           stheta    = -p.z()/v.z();
           sidetheta = kSTheta;
@@ -2340,24 +2013,22 @@
       else // kons is not plane 
       {
-        tanSTheta2  = tanSTheta*tanSTheta;
         t1          = 1-v.z()*v.z()*(1+tanSTheta2);
         t2          = pDotV2d-p.z()*v.z()*tanSTheta2;  // ~vDotN if p on cons
-        dist2STheta = rho2-p.z()*p.z()*tanSTheta2;      // t3
-
-        // distTheta = std::sqrt(std::fabs(dist2STheta/(1+tanSTheta2)));
+        dist2STheta = rho2-p.z()*p.z()*tanSTheta2;     // t3
+
         distTheta = std::sqrt(rho2)-p.z()*tanSTheta;
 
-        if( std::fabs(t1) < 0.5*kAngTolerance ) // 1st order equation, v parallel to kons
-        {
+        if( std::fabs(t1) < halfAngTolerance ) // 1st order equation,
+        {                                      // v parallel to kons
           if( v.z() > 0. )
           {
-            if(std::fabs(distTheta) < flexRadMaxTolerance*0.5) // p on surface
-            {
-              if( fSTheta < halfpi && p.z() > 0. )
-              {
-                if( calcNorm ) *validNorm = false;
-                              return snxt = 0.;
-              }
-              else if( fSTheta > halfpi && p.z() <= 0)
+            if(std::fabs(distTheta) < halfRmaxTolerance) // p on surface
+            {
+              if( (fSTheta < halfpi) && (p.z() > 0.) )
+              {
+                if( calcNorm )  { *validNorm = false; }
+                return snxt = 0.;
+              }
+              else if( (fSTheta > halfpi) && (p.z() <= 0) )
               {
                 if( calcNorm ) 
